### Hierarchy

- ProcessEngineService

### Implements

- IProcessEngineService

## Index

### Constructors

- constructor

### Properties

- _applicationService
- _datastoreService
- _errorDeserializer
- _eventAggregator
- _executeProcessService
- _featureService
- _iamService
- _internalContext
- _invoker
- _messageBusService
- _nodeInstanceEntityTypeService
- _nodeInstanceEntityTypeServiceFactory
- _processDefEntityTypeService
- _processRepository
- config

### Accessors

- applicationService
- datastoreService
- errorDeserializer
- eventAggregator
- featureService
- iamService
- invoker
- messageBusService
- processDefEntityTypeService
- processRepository

### Methods

- _continueOwnProcess
- _continueOwnProcesses
- _createProcessInstanceRemotely
- _executeProcessInstanceLocally
- _executeProcessInstanceRemotely
- _executeProcessLocally
- _executeProcessRemotely
- _getAllWaitingNodes
- _getInternalContext
- _getNodeInstanceEntityTypeService
- _getSpecificEntityByNodeInstance
- _initializeDefaultErrorDeserializer
- _initializeMessageBus
- _initializeProcesses
- _messageHandler
- _nodeAlreadyBelongsToOtherProcessEngine
- _startTimers
- _timeoutPromise
- _waitForMessagebus
- createBpmnFromXml
- createProcessInstance
- executeProcess
- executeProcessInstance
- getUserTaskData
- handleProcessEngineMessage
- initialize
- setErrorDeserializer
- start

## Constructors

### constructor

- new ProcessEngineService(messageBusService: IMessageBusService, eventAggregator: IEventAggregator, processDefEntityTypeService: IProcessDefEntityTypeService, executeProcessService: IExecuteProcessService, featureService: IFeatureService, iamService: IIamService, processRepository: IProcessRepository, datastoreService: IDatastoreService, nodeInstanceEntityTypeServiceFactory: IFactoryAsync<INodeInstanceEntityTypeService>, applicationService: IApplicationService, invoker: IInvoker): ProcessEngineService

- - Defined in process_engine_service.ts:60

  #### Parameters

  - ##### messageBusService: IMessageBusService

  - ##### eventAggregator: IEventAggregator

  - ##### processDefEntityTypeService: IProcessDefEntityTypeService

  - ##### executeProcessService: IExecuteProcessService

  - ##### featureService: IFeatureService

  - ##### iamService: IIamService

  - ##### processRepository: IProcessRepository

  - ##### datastoreService: IDatastoreService

  - ##### nodeInstanceEntityTypeServiceFactory: IFactoryAsync<INodeInstanceEntityTypeService>

  - ##### applicationService: IApplicationService

  - ##### invoker: IInvoker

  #### Returns ProcessEngineService

## Properties

### Private _applicationService

_applicationService: IApplicationService = undefined

- Defined in process_engine_service.ts:55

### Private _datastoreService

_datastoreService: IDatastoreService = undefined

- Defined in process_engine_service.ts:52

### Private _errorDeserializer

_errorDeserializer: IErrorDeserializer = undefined

- Defined in process_engine_service.ts:57

### Private _eventAggregator

_eventAggregator: IEventAggregator = undefined

- Defined in process_engine_service.ts:46

### Private _executeProcessService

_executeProcessService: IExecuteProcessService = undefined

- Defined in process_engine_service.ts:48

### Private _featureService

_featureService: IFeatureService = undefined

- Defined in process_engine_service.ts:49

### Private _iamService

_iamService: IIamService = undefined

- Defined in process_engine_service.ts:50

### Private _internalContext

_internalContext: ExecutionContext

- Defined in process_engine_service.ts:59

### Private _invoker

_invoker: IInvoker = undefined

- Defined in process_engine_service.ts:56

### Private _messageBusService

_messageBusService: IMessageBusService = undefined

- Defined in process_engine_service.ts:45

### Private _nodeInstanceEntityTypeService

_nodeInstanceEntityTypeService: INodeInstanceEntityTypeService = undefined

- Defined in process_engine_service.ts:54

### Private _nodeInstanceEntityTypeServiceFactory

_nodeInstanceEntityTypeServiceFactory: IFactoryAsync<INodeInstanceEntityTypeService> = undefined

- Defined in process_engine_service.ts:53

### Private _processDefEntityTypeService

_processDefEntityTypeService: IProcessDefEntityTypeService = undefined

- Defined in process_engine_service.ts:47

### Private _processRepository

_processRepository: IProcessRepository = undefined

- Defined in process_engine_service.ts:51

### config

config: any = undefined

- Defined in process_engine_service.ts:60

## Accessors

### Private applicationService

- get applicationService(): IApplicationService

- - Defined in process_engine_service.ts:122

  #### Returns IApplicationService

### Private datastoreService

- get datastoreService(): IDatastoreService

- - Defined in process_engine_service.ts:110

  #### Returns IDatastoreService

### Private errorDeserializer

- get errorDeserializer(): IErrorDeserializer

- - Defined in process_engine_service.ts:130

  #### Returns IErrorDeserializer

### Private eventAggregator

- get eventAggregator(): IEventAggregator

- - Defined in process_engine_service.ts:90

  #### Returns IEventAggregator

### Private featureService

- get featureService(): IFeatureService

- - Defined in process_engine_service.ts:98

  #### Returns IFeatureService

### Private iamService

- get iamService(): IIamService

- - Defined in process_engine_service.ts:102

  #### Returns IIamService

### Private invoker

- get invoker(): IInvoker

- - Defined in process_engine_service.ts:126

  #### Returns IInvoker

### Private messageBusService

- get messageBusService(): IMessageBusService

- - Defined in process_engine_service.ts:86

  #### Returns IMessageBusService

### Private processDefEntityTypeService

- get processDefEntityTypeService(): IProcessDefEntityTypeService

- - Defined in process_engine_service.ts:94

  #### Returns IProcessDefEntityTypeService

### Private processRepository

- get processRepository(): IProcessRepository

- - Defined in process_engine_service.ts:106

  #### Returns IProcessRepository

## Methods

### Private _continueOwnProcess

- _continueOwnProcess(context: ExecutionContext, waitingNode: INodeInstanceEntity): Promise<any>

- - Defined in process_engine_service.ts:389

  #### Parameters

  - ##### context: ExecutionContext

  - ##### waitingNode: INodeInstanceEntity

  #### Returns Promise<any>

### Private _continueOwnProcesses

- _continueOwnProcesses(): Promise<any>

- - Defined in process_engine_service.ts:368

  #### Returns Promise<any>

### Private _createProcessInstanceRemotely

- _createProcessInstanceRemotely(context: ExecutionContext, requiredFeatures: Array<IFeature>, id: string, key: string, version?: string): Promise<any>

- - Defined in process_engine_service.ts:725

  #### Parameters

  - ##### context: ExecutionContext

  - ##### requiredFeatures: Array<IFeature>

  - ##### id: string

  - ##### key: string

  - ##### Optional version: string

  #### Returns Promise<any>

### Private _executeProcessInstanceLocally

- _executeProcessInstanceLocally(context: ExecutionContext, processInstance: IProcessEntity, participantId: string, initialToken: any): Promise<any>

- - Defined in process_engine_service.ts:629

  #### Parameters

  - ##### context: ExecutionContext

  - ##### processInstance: IProcessEntity

  - ##### participantId: string

  - ##### initialToken: any

  #### Returns Promise<any>

### Private _executeProcessInstanceRemotely

- _executeProcessInstanceRemotely(context: ExecutionContext, requiredFeatures: Array<IFeature>, processInstanceId: string, participantId: string, initialToken: any): Promise<any>

- - Defined in process_engine_service.ts:695

  #### Parameters

  - ##### context: ExecutionContext

  - ##### requiredFeatures: Array<IFeature>

  - ##### processInstanceId: string

  - ##### participantId: string

  - ##### initialToken: any

  #### Returns Promise<any>

### Private _executeProcessLocally

- _executeProcessLocally(context: ExecutionContext, processDefinition: IProcessDefEntity, initialToken: any): Promise<any>

- - Defined in process_engine_service.ts:585

  #### Parameters

  - ##### context: ExecutionContext

  - ##### processDefinition: IProcessDefEntity

  - ##### initialToken: any

  #### Returns Promise<any>

### Private _executeProcessRemotely

- _executeProcessRemotely(context: ExecutionContext, requiredFeatures: Array<IFeature>, id: string, key: string, initialToken: any, version?: string): Promise<any>

- - Defined in process_engine_service.ts:663

  #### Parameters

  - ##### context: ExecutionContext

  - ##### requiredFeatures: Array<IFeature>

  - ##### id: string

  - ##### key: string

  - ##### initialToken: any

  - ##### Optional version: string

  #### Returns Promise<any>

### Private _getAllWaitingNodes

- _getAllWaitingNodes(): Promise<Array<INodeInstanceEntity>>

- - Defined in process_engine_service.ts:409

  #### Returns Promise<Array<INodeInstanceEntity>>

### Private _getInternalContext

- _getInternalContext(): Promise<ExecutionContext>

- - Defined in process_engine_service.ts:134

  #### Returns Promise<ExecutionContext>

### Private _getNodeInstanceEntityTypeService

- _getNodeInstanceEntityTypeService(): Promise<INodeInstanceEntityTypeService>

- - Defined in process_engine_service.ts:114

  #### Returns Promise<INodeInstanceEntityTypeService>

### Private _getSpecificEntityByNodeInstance

- _getSpecificEntityByNodeInstance(context: ExecutionContext, nodeInstance: INodeInstanceEntity): Promise<INodeInstanceEntity>

- - Defined in process_engine_service.ts:462

  #### Parameters

  - ##### context: ExecutionContext

  - ##### nodeInstance: INodeInstanceEntity

  #### Returns Promise<INodeInstanceEntity>

### Private _initializeDefaultErrorDeserializer

- _initializeDefaultErrorDeserializer(): void

- - Defined in process_engine_service.ts:142

  #### Returns void

### Private _initializeMessageBus

- _initializeMessageBus(): Promise<void>

- - Defined in process_engine_service.ts:298

  #### Returns Promise<void>

### Private _initializeProcesses

- _initializeProcesses(): Promise<void>

- - Defined in process_engine_service.ts:323

  #### Returns Promise<void>

### Private _messageHandler

- _messageHandler(msg: any): Promise<void>

- - Defined in process_engine_service.ts:225

  #### Parameters

  - ##### msg: any

  #### Returns Promise<void>

### Private _nodeAlreadyBelongsToOtherProcessEngine

- _nodeAlreadyBelongsToOtherProcessEngine(context: ExecutionContext, node: INodeInstanceEntity): Promise<boolean>

- - Defined in process_engine_service.ts:436

  #### Parameters

  - ##### context: ExecutionContext

  - ##### node: INodeInstanceEntity

  #### Returns Promise<boolean>

### Private _startTimers

- _startTimers(): Promise<void>

- - Defined in process_engine_service.ts:348

  #### Returns Promise<void>

### Private _timeoutPromise

- _timeoutPromise(milliseconds: number): Promise<void>

- - Defined in process_engine_service.ts:481

  #### Parameters

  - ##### milliseconds: number

  #### Returns Promise<void>

### Private _waitForMessagebus

- _waitForMessagebus(): Promise<void>

- - Defined in process_engine_service.ts:489

  #### Returns Promise<void>

### createBpmnFromXml

- createBpmnFromXml(context: ExecutionContext, xml: string): Promise<IProcessDefEntity>

- - Defined in process_engine_service.ts:201

  #### Parameters

  - ##### context: ExecutionContext

  - ##### xml: string

  #### Returns Promise<IProcessDefEntity>

### createProcessInstance

- createProcessInstance(context: ExecutionContext, processDefId: string, key: string, version?: string): Promise<string>

- - Defined in process_engine_service.ts:549

  #### Parameters

  - ##### context: ExecutionContext

  - ##### processDefId: string

  - ##### key: string

  - ##### Optional version: string

  #### Returns Promise<string>

### executeProcess

- executeProcess(context: ExecutionContext, id: string, key: string, initialToken: any, version?: string): Promise<any>

- - Defined in process_engine_service.ts:503

  #### Parameters

  - ##### context: ExecutionContext

  - ##### id: string

  - ##### key: string

  - ##### initialToken: any

  - ##### Optional version: string

  #### Returns Promise<any>

### executeProcessInstance

- executeProcessInstance(context: ExecutionContext, processInstanceId: string, participantId: string, initialToken: any): Promise<any>

- - Defined in process_engine_service.ts:531

  #### Parameters

  - ##### context: ExecutionContext

  - ##### processInstanceId: string

  - ##### participantId: string

  - ##### initialToken: any

  #### Returns Promise<any>

### getUserTaskData

- getUserTaskData(context: ExecutionContext, userTaskId: string): Promise<IUserTaskMessageData>

- - Defined in process_engine_service.ts:180

  #### Parameters

  - ##### context: ExecutionContext

  - ##### userTaskId: string

  #### Returns Promise<IUserTaskMessageData>

### Private handleProcessEngineMessage

- handleProcessEngineMessage(message: IDataMessage): Promise<void>

- - Defined in process_engine_service.ts:264

  #### Parameters

  - ##### message: IDataMessage

  #### Returns Promise<void>

### initialize

- initialize(): Promise<void>

- - Defined in process_engine_service.ts:160

  #### Returns Promise<void>

### setErrorDeserializer

- setErrorDeserializer(deserializer: IErrorDeserializer): void

- - Defined in process_engine_service.ts:581

  #### Parameters

  - ##### deserializer: IErrorDeserializer

  #### Returns void

### start

- start(context: ExecutionContext, params: IParamStart, options?: IPublicGetOptions): Promise<string>

- - Defined in process_engine_service.ts:175

  #### Parameters

  - ##### context: ExecutionContext

  - ##### params: IParamStart

  - ##### Optional options: IPublicGetOptions

  #### Returns Promise<string>

Generated using TypeDoc